package controllers

import (
	"github.com/astaxie/beego"
	"github.com/usual2970/util/git-module"
	"github.com/astaxie/beego/logs"
	"regexp"
	"fmt"
	"github.com/upyun/go-sdk/upyun"
	"os"
)

type GitController struct {
	beego.Controller
}

var log=&logs.BeeLogger{}

type HookInfo struct{
	Password string `json:"password"`
	HookName string `json:"hook_name"`
	PushData *PData `json:"push_data"`
}

type PData struct{
	Before string `json:"before"`
	After string `json:"after"`
	Ref string `json:"ref"`
}
/**
 * 静态资源更新后自动同步到又拍云
 * @param  {[type]} c *GitController) Hook( [description]
 * @return {[type]}   [description]
 */
func (c *GitController) Hook() {
	repoPath:="/var/www/static.yidianling.com/"
	options:=git.PullRemoteOptions{false,0}
	info,_:=git.Pull(repoPath,options)
	re := regexp.MustCompile("\\s+(.*)\\s+\\|\\s+\\d+\\s.*\n")
	upList:=re.FindAllStringSubmatch(string(info),-1)


	up:=upyun.NewUpYun(beego.AppConfig.String("upbucket"),beego.AppConfig.String("upusername"),beego.AppConfig.String("uppassword"))

	if len(upList)>0{
		for _,v:=range upList{
			fd,err:=os.Open(repoPath+v[1])
			if err!=nil{
				continue
			}
			_,err=up.Put("/"+v[1],fd,false,nil)
			if err!=nil{
				fmt.Println(err)
			}
			fmt.Println(v[1])
			fd.Close()
		}
	}

	crRe:= regexp.MustCompile("\\s+create\\s+mode\\s+\\d+\\s+([^\\s]*)")
	crList:=crRe.FindAllStringSubmatch(string(info),-1)
	if len(crList)>0{
		for _,cr:=range crList{
			
			fd,err:=os.Open(repoPath+cr[1])
			if err!=nil{
				continue
			}
			up.Put("/"+cr[1],fd,false,nil)
			fmt.Println(cr[1])
			fd.Close()
		}
	}


	log.Info(string(info))
}



func init(){

	log=logs.NewLogger(64)
	log.SetLogger("file",`{"filename":"test.log"}`)
}