package controllers

import (
	"github.com/astaxie/beego"
	"github.com/usual2970/util/tel"
	"github.com/usual2970/util/service/models"
)

type TelController struct {
	beego.Controller
}

func (c *TelController) Dial() {
	rs:=&models.Result{"0","success",nil}
	for{
		from:=c.GetString("from")
		if from==""{
			rs.ErrNo="1"
			rs.Msg="请提交主叫号码"
			break
		}
		to:=c.GetString("to")
		if to==""{
			rs.ErrNo="2"
			rs.Msg="请提交被叫号码"
			break
		}

		telObj:=tel.NewTel(from,to)

		resp,err:=telObj.Dial()
		if err!=nil{
			rs.ErrNo="2"
			rs.Msg="拨打失败"
			break
		}
		
		rs.Data=resp
		break
	}
	
	c.Data["json"] = rs
	c.ServeJSON()
}

func (c *TelController) Cancel(){
	rs:=&models.Result{"0","success",nil}
	for{
		from,to:="",""
		sessionId:=c.GetString("sessionId")
		if sessionId==""{
			rs.ErrNo="1"
			rs.Msg="请提交会话ID"
			break
		}

		telObj:=tel.NewTel(from,to)
		resp,err:=telObj.Cancel(sessionId)
		if err!=nil{
			rs.ErrNo="2"
			rs.Msg="取消失败"
			break
		}
		rs.Data=resp
		break
	}

	c.Data["json"] = rs
	c.ServeJSON()
}
